const sortOrderList = () => {
  var ul = jQuery("#sitemap-order");
  var arr = jQuery.makeArray(ul.children("li"));

  arr.sort(function (a, b) {
    var textA = a.value;
    var textB = b.value;

    if (textA < textB) return -1;
    if (textA > textB) return 1;

    return 0;
  });

  ul.empty();

  jQuery.each(arr, function () {
    ul.append(this);
  });
}

const eventNeedToUpdateOrderList = new Event('click5_sitemap_force_order_list_update');

const relocateSubItems = () => {
  document.querySelectorAll('#sitemap-order > li > ol li').forEach(subli => {
    if(subli.hasAttribute('name')) {
      let newLocation = subli.getAttribute('name');
      if (subli.parentElement.parentElement) {
        if (subli.parentElement.parentElement.hasAttribute('data-value')) {
          if (newLocation !== subli.parentElement.parentElement.getAttribute('data-value')) {
            //document.querySelector('#sitemap-order li[data-value="' + newLocation + '"] > ol').append(subli);
          }
        }
      }

    }
  });
}

const sortSubOrderList = () => {
  document.querySelectorAll('#sitemap-order > li ol').forEach(ol => {
    var ul = jQuery(ol);
    var arr = jQuery.makeArray(ul.children("li"));

    arr.sort(function (a, b) {
      var textA = a.value;
      var textB = b.value;

      if (textA < textB) return -1;
      if (textA > textB) return 1;

      return 0;
    });

    ul.empty();

    jQuery.each(arr, function () {
      ul.append(this);
    });
  })
}

const sortListByCurrentSortData = () => {
  getRequest(c5resturl.wpjson + 'click5_sitemap/API/get_sitemap_order', (data) => {
    if (data) {
      if(data.length) {
        data.forEach(sortObject => {
          sortElement = document.querySelector('li[data-value="'+sortObject.ID+'"]');
          if(sortElement) {
            sortElement.setAttribute('value', sortObject.order);
            if (sortObject.parent) {
              sortElement.setAttribute('name', sortObject.parent);
            }
          }
        });
        sortOrderList();
        relocateSubItems();
        sortSubOrderList();

        //console.log('loaded');
        jQuery("#btnSaveOrder").trigger('click');
      }
    }
  });
}

const loadOrderList = (callback = undefined) => {
  getRequest(c5resturl.wpjson + 'click5_sitemap/API/get_order_list_HTML', (data) => {
    let list = '<div class="dd" id="orderList"><ol class="dd-list" id="sitemap-order">';
    if (data) {
      if (data.length) {
        //console.log(data);
        list += data;
      }
    }
    list += '</ol></div>';

    let listEl = jQuery(list);
    jQuery(listEl).hide();
    jQuery('#post-body-content > #order-sitemap > div').prepend(listEl);
    sortListByCurrentSortData();
    jQuery(listEl).show();

    getRequest(c5resturl.wpjson + 'click5_sitemap/API/get_nested_elements', (nestedElements) => {
      
      let currentParrent;

      jQuery('#orderList').nestable({
        maxDepth: 3,
        expandBtnHTML: '<button class="dd-expand" data-action="expand" type="button"></button>',
        collapseBtnHTML: '<button class="dd-collapse" data-action="collapse" type="button"></button>',
        onDragStart: function(l,e){
          currentParrent = jQuery(e).parent().closest('li').attr('data-value')
        },
        beforeDragStop: function(l, e, p){

            var currentElementValue = jQuery(e).attr('data-value')
            var currentElementValueTitle = jQuery(e).find('.dd-handle').text()
            var newParentValue = p[0].offsetParent.dataset.value

            if(jQuery(e).hasClass("group") && p[0].offsetParent.className.includes('group')){
              return false;
            }

            if(jQuery(e).hasClass('sub-item') && p[0].getAttribute('id') === 'sitemap-order') {
              return false;
            }

            if (!jQuery(e).hasClass("group") && currentParrent != newParentValue) {

              jQuery(e).attr('name', newParentValue);

              if(!jQuery(e).hasClass('original-nested')){
                jQuery(e).addClass('custom-nested');
              }
              
              let main_list = false;
              if ((jQuery('li.dd-item.group[data-value='+newParentValue+']').length > 0) && jQuery(e).hasClass('custom-nested')){
                main_list = true;
              }

              let original_parent = false;
              if(jQuery(e).hasClass('original-nested')){
                original_parent = currentParrent
              }

              let toOriginalNested = false;
              p[0].childNodes.forEach(childNode => {
                if(childNode.className.includes('original-nested')){
                  toOriginalNested = true;
                }
              });

              item = {
                element: currentElementValue,
                parent: newParentValue,
                title: currentElementValueTitle,
                original_parent: original_parent,
                toOriginalNested: toOriginalNested
              };
      
              var added = false;
              jQuery.map(nestedElements, function(elementOfArray, indexInArray) {
                if (elementOfArray.element == item.element) {
                  added = true;
                }
              });
              if (!added) {
                nestedElements.push(item);
              } else {
                jQuery.each( nestedElements, function( key, value ) {
                  if( value.element == item.element) {
                      value.parent = item.parent;
                  }
                });
              }

              if(main_list){
                nestedElements = jQuery.grep(nestedElements, function(value) {
                  return value.element != item.element;
                });
              }

              if(original_parent){
                nestedElements = jQuery.grep(nestedElements, function(value) {
                  return value.original_parent != item.parent;
                });
              }
      
              postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/post_update_nested_elements', nestedElements, (data) => {
                console.log('saved nested elements');
              });

            }

        }
      })
      jQuery('#orderList').nestable('collapseAll');

      jQuery("#orderList li.sub-item").each(function() {
        var this_elem = jQuery(this)
        if (this_elem.hasClass("dd-collapsed")) {
          this_elem.removeClass("dd-collapsed")
        }
        if(this_elem.find('ol li').length == 0){
          var handlediv = this_elem.find('div.dd-handle').detach();
          this_elem.empty().append(handlediv);
        }

        var original_nested = this_elem.find('ol li').not('.custom-nested');
        original_nested.addClass('original-nested')
        
      });

    });

    if (callback) {
      callback();
    }
  });
};

//recursive
const getOrderElement = (node) => {
  if (node.childElementCount > 1) {
    let nodeObj = { ID: node.getAttribute('data-value'), children: [] }
    node.lastElementChild.childNodes.forEach(childNode => {
      nodeObj.children.push(getOrderElement(childNode, nodeObj));
    });
    return nodeObj;
  } else {
    return { ID: node.getAttributeNode("data-value").value };
  }
}

const serializeOrderList = () => {
  let arrayResult = [];
  document.querySelectorAll('#sitemap-order > *').forEach(firstLevelNode => {
    arrayResult.push(getOrderElement(firstLevelNode));
  });
  postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/post_update_list_HTML', arrayResult, (data) => {
    click5_sitemap_notification('success', 'HTML Sitemap order has been updated.');
  });
}

const BTNserializeOrderList = () => {
  let arrayResult = [];

  document.querySelectorAll('#sitemap-order > *').forEach(firstLevelNode => {
    arrayResult.push(getOrderElement(firstLevelNode));
  });

  postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/post_update_list_HTML_save_btn', arrayResult, (data) => {
    //console.log('default order');
  });
}

const reloadOrderList = (callback = undefined) => {
  document.querySelector('#sitemap-order').remove();
  loadOrderList(callback);

  //console.log('reload');
}

const updateEnableCustomHeading = (checkboxElement) => {
  const option_name = checkboxElement.getAttribute('name');
  const option_value = checkboxElement.checked;
  postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'bool' }, (data) => {
    if (data == true) {
      click5_sitemap_notification('success', 'Settings saved.', 2000);
      reloadOrderList(serializeOrderList);
    }
  });
}

const copyToClipboard = (str) => {
  const el = document.createElement('textarea');
  el.value = str;
  document.body.appendChild(el);
  el.select();
  document.execCommand('copy');
  document.body.removeChild(el);
  click5_sitemap_notification('success', 'Copied to clipboard.', 2000);
}

const resetSitemapOrder = () => {
  postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/reset_sitemap_order', {}, (data) => {
    click5_sitemap_notification('success', 'Default Sitemap order has been applied.', 2000);
    if (data) {
      if (data.length) {
        reloadOrderList(serializeOrderList);
      }
    }
  });

  return true;
}


const TotalresetSitemapOrder = () => {
  postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/total_reset_sitemap_order', {}, (data) => {
    click5_sitemap_notification('success', 'Default Sitemap order has been applied.', 2000);
    if (data) {
      if (data.length) {
        reloadOrderList(serializeOrderList);
      }
    }
  });
}

(() => {
  document.addEventListener("DOMContentLoaded", function (event) {
    if (hasParameter('&tab=seo') || hasParameter('&tab=urls')) {
      return;
    }

    loadOrderList();


    toggleLoader('loader_results', true);
    toggleLoader('loader_blacklisted', true);

  
    let inputSearch = document.querySelector('#page_search');
    let selectType = document.querySelector('#page_type');
    let hiddenAllTypes = document.querySelector('#all_types');

    document.querySelector('#btnSaveOrder').addEventListener('click', function (e) {


      e.preventDefault();
      e.stopPropagation();
      serializeOrderList();
      BTNserializeOrderList();


    });

    document.addEventListener('click5_sitemap_force_order_list_update', function() {
      reloadOrderList(serializeOrderList);
    });

    document.getElementById('btnClearBlacklist').addEventListener('click', function (e) {
      e.preventDefault();
      e.stopPropagation();

      confirm('Are you sure you want delete all blacklisted pages?');

      getRequest(c5resturl.wpjson + 'click5_sitemap/API/clear_blacklist', (data) => {
        if (data == true) {
          document.querySelectorAll('#click5_sitemap_already_blacklisted > li').forEach(el => {
            el.remove();
          });
          //loadBlacklist();
          reloadOrderList(serializeOrderList);
          searchFunc(inputSearch, selectType, hiddenAllTypes);
          this.style.display = 'none';
          click5_sitemap_notification('success', 'Blacklist saved.', 2000);
        } else {
          click5_sitemap_notification('error', 'Something went wrong.', 2000);
        }
      });
    });

    document.getElementById('btnResetOrder').addEventListener('click', function(e) {
      e.preventDefault();
      e.stopPropagation();

      TotalresetSitemapOrder();
    });
    
    document.querySelectorAll('#enableSitemap input[type="checkbox"]').forEach(checkbox => {
      checkbox.addEventListener('change', function(e) {
        updateEnableCustomHeading(this);
        resetSitemapOrder();
      });
    });
    document.querySelectorAll('#enableSitemap select:not(#click5_sitemap_html_blog_group_by)').forEach(checkbox => {
      checkbox.addEventListener('change', function(e) {
        const option_name = this.getAttribute('name');
        const option_value = this.value;
        postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'text' }, (data) => {
          resetSitemapOrder();
        });
      });
    });

    document.querySelectorAll('#enableSitemap #click5_sitemap_html_blog_group_by').forEach(checkbox => {
      checkbox.addEventListener('change', function(e) {
        const option_name = this.getAttribute('name');
        const option_value = this.value;
        postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'text' }, (data) => {
          
          if(resetSitemapOrder()){
            window.location.href = window.location.href
          }
          
        });
      });
    });

    document.querySelectorAll('#enableSitemap input[type="number"]').forEach(checkbox => {
      checkbox.addEventListener('change', debounce(function (e) {
        const option_name = this.getAttribute('name');
        const option_value = parseInt(this.value);
        postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'text' }, (data) => {
          if (data == true) {
            click5_sitemap_notification('success', 'Settings saved.', 2000);
            resetSitemapOrder();
          }
        });
      }, 300));
    });
    document.querySelectorAll('#enableSitemap input[type="text"]').forEach(checkbox => {
      checkbox.addEventListener('input', debounce(function(e) {
        const option_name = this.getAttribute('name');
        const option_value = this.value;
        if (option_value.length) {
          this.previousElementSibling.control.checked = true;
        } else {
          this.previousElementSibling.control.checked = false;
        }

        postRequestJSON(c5resturl.wpjson + 'click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'text' }, (data) => {
          if (data == true) {
            click5_sitemap_notification('success', 'Settings saved.', 2000);
            updateEnableCustomHeading(this.previousElementSibling.control);
            resetSitemapOrder();
          }
        });
      }, 300));
    });

    loadBlacklist();

    document.addEventListener('blacklist_updated', () => {
      //reloadOrderList(serializeOrderList);
      resetSitemapOrder();
    });

    searchFunc(inputSearch, selectType, hiddenAllTypes);


    selectType.addEventListener('change', function (e) {
      searchFunc(inputSearch, selectType, hiddenAllTypes);
    });
    inputSearch.addEventListener('input', debounce(function (e) {
      searchFunc(inputSearch, selectType, hiddenAllTypes);
    }, 300));

    document.querySelector('#copy-me').addEventListener('click', function(e) {
      e.preventDefault();
      e.stopPropagation();
  
      const toCopy = this.querySelector('strong').innerText.trim();
      copyToClipboard(toCopy);
    });
  });


})();